Website Monitoring - Bug #2509
Bug # 2500 (Closed): Doesn't work on Splunk 8.0

Test failures related to NTLM
11/12/2019 01:40 AM - Luke Murphey

Status: Closed Start date: 11/11/2019
Priority: Normal Due date:

Assignee: Luke Murphey % Done: 100%
Category: Estimated time: 0.00 hour
Target version: 2.8

Description

Associated revisions

Revision 493 - 11/12/2019 02:08 AM - luke.murphey
Updating MD4 to work on Python 3

Reference #2509

Revision 498 - 11/12/2019 05:43 AM - luke.murphey

Fixing NTLM issues with the test server

Reference #2509

Revision 500 - 11/12/2019 05:48 AM - luke.murphey

Making tests no longer swallow exceptions

Reference #2509

Revision 502 - 11/12/2019 06:40 AM - luke.murphey

Reaplcing the MD4 implementation with one that works on Python 3

Reference #2509

History

#1 - 11/12/2019 02:10 AM - Luke Murphey
- Status changed from New to Closed

- % Done changed from 0 to 100
#2 - 11/12/2019 05:22 AM - Luke Murphey

- Status changed from Closed to In Progress

- % Done changed from 100 to 50

[exec]

[exec] FAIL: test_determine_auth _method_ntlm (__main__ .TestWebPing)

[exec]
Traceback (most recent call last):
File "unit.py", line 166, in _decorator
return func(self, *args, **kwargs)
File "unit.py", line 417, in test_determine_auth_method ntlm
self.assertEqual (auth_type, WebPing.HTTP_AUTH_NTLM)
AssertionError: None != 'ntlm'

FAIL: test_determine_auth_method_ntlm_comma_header (__main__ .TestWebPing)

Traceback (most recent call last):
File "unit.py", line 166, in _decorator
return func(self, *args, **kwargs)
File "unit.py", line 426, in test_determine_auth_method_ntlm_comma_header
self.assertEqual (auth_type, WebPing.HTTP_AUTH_NTLM)
AssertionError: None != 'ntlm'

FAIL: test_ping_over_proxy (__main__.TestWebPing)

Traceback (most recent call last):

File "unit.py", line 37, in _decorator
return func(self, *args, **kwargs)
File "unit.py", line 326, in test_ping_over_proxy
self.assertEqual (result.response_code, 200)
AssertionError: 0 != 200
FAIL: test_ping_with_ntlm_authentication (__main__.TestWebPing)

Traceback (most recent call last):
File "unit.py", line 166, in _decorator
return func(self, *args, **kwargs)
File "unit.py", line 361, in test_ping_with_ntlm_authentication
self.assertEqual (result.response_code, 200)
AssertionError: 0 != 200

FAIL: test_ping_with_ntlm authentication_missing_domain (__main__.TestWebPing)

Traceback (most recent call last):

File "unit.py", line 376, in test_ping with_ntlm_authentication_missing_domain
self.assertRaises (NTLMAuthenticationValueException, lambda: WebPing.ping( url_field.to_python (
0.0.1:" + str(self.web_server_port) + "/ntlm_auth"), timeout=3, username="user", password="passwd"

AssertionError: NTLMAuthenticationValueException not raised by <lambda>

FAIL: test_ping_with_ntlm negotiate_authentication (__main__.TestWebPing)

Traceback (most recent call last):
File "unit.py", line 166, in _decorator
return func(self, *args, **kwargs)
File "unit.py", line 370, in test_ping with_ntlm_negotiate_authentication
self.assertEqual (result.response_code, 200)
AssertionError: 0 != 200
#3 - 11/12/2019 05:43 AM - Luke Murphey

Questions:
e Why does this work locally but not on the Cl system?
o It appears that the test on Linux are using Python 3 because | see "ResourceWarning: unclosed <socket.socket fd=6..."
¢ Does the HTTP messages show a different trace?
* Do | get the same errors on Python 3?
o ldo
Observations:

¢ Here is a functioning trace of TestWebPing.test_ping_with_ntlm_authentication:

test.run_unit:

[exec] 127.0.0.1 - - [11/Nov/2019 21:55:29] "GET /ntlm_auth HTTP/1.1" 401 -
[exec] 127.0.0.1 - - [11/Nov/2019 21:55:29] "GET /ntlm_auth HTTP/1.1" 401 -
[exec] 127.0.0.1 - - [11/Nov/2019 21:55:29] "GET /ntlm_auth HTTP/1.1" 401 -
[exec] 127.0.0.1 - - [11/Nov/2019 21:55:29] "GET /ntlm_auth HTTP/1.1" 200 -
[exec]

[exec] 7"~ ————

[exec] Ran 1 test in 0.042s

[exec]

[exec] OK

[exec] Waiting for web-server to start ... Done

[exec] ('Authorization Header:', None)

[exec] Performing initial NTLM auth

[exec] ('Authorization Header:', None)

[exec] Performing initial NTLM auth

[exec] ('Authorization Header:', 'NTLM T1RMTVNTUAABAAAAB7IIogQABAAG6AAAAEgASACgAAAAFASgKAAAADOXNVVJIQSE

VZLU1CUCO1INOYXNVVTIRVI=")

[exec] Performing NTLM auth challenge

[exec] ('Authorization Header:', 'NTLM T1RMTVNTUAADAAAAGAAYAIAAAAAYABgAmAAAAAgACABIAAAADAAMAFAAAAAKAC
QAXAAAAAAAAACWAAAABYKIogUBKAOAAAAPVQBTAEUAUgBKAGS8ALOBhAGKkALbgBMAEOAVQOBSAFAASABFAFKALQBNAEIAUAAtADUANWBGADEA
NQCOR1gd+aRHAt0883ylFZiXV+mht 5VAw3TRUa8504UTOBvSBjRmcDRbwsvSkncGUSY=")

[exec] Completing NTLM auth

¢ Here is the failing state:

[exec] unit.py:113: ResourceWarning: unclosed file <_io.TextIOWrapper name='../local.properties' mode
='r' encoding='UTF-8'>

[exec] self.loadConfig()

[exec] ResourceWarning: Enable tracemalloc to get the object allocation traceback

[exec] 127.0.0.1 - - [11/Nov/2019 21:56:59] "GET /ntlm_auth HTTP/1.1" 401 -

[exec] 127.0.0.1 - - [11/Nov/2019 21:56:59] "GET /ntlm_auth HTTP/1.1" 401 -

[exec] 127.0.0.1 - - [11/Nov/2019 21:56:59] "GET /ntlm_auth HTTP/1.1" 401 -

[exec] F

[exec]

[exec] FAIL: test_ping_with_ntlm_authentication (__main__ .TestWebPing)

[exec] -7~ ————————

[exec] Traceback (most recent call last):

[exec] File "unit.py", line 166, in _decorator

[exec] return func(self, *args, **kwargs)

[exec] File "unit.py", line 361, in test_ping_with_ntlm_authentication

[exec] self.assertEqual (result.response_code, 200)

[exec] AssertionError: 0 != 200

[exec]
[exec] Ran 1 test in 20.070s

[exec]

[exec] FAILED (failures=1l)

[exec] Waiting for web-server to start ........ Done

[exec] Authorization Header: None

[exec] Performing initial NTLM auth

[exec] Authorization Header: None

[exec] Performing initial NTLM auth

[exec] Authorization Header: NTLM T1RMTVNTUAABAAAAB7IIogQABAAG6AAAAEgASACgAAAAFASgKAAAADOXNVVJIQSEVZLUL
CUCOLNOYxNVVTRVI=

[exec] Performing NTLM auth challenge

e Changing the build target for "test.run" to python2 would likely make it pass

04/23/2024 3/4



#4 - 11/12/2019 06:40 AM - Luke Murphey
- Status changed from In Progress to Closed

- % Done changed from 50 to 100
